searchData={"items":[{"type":"module","title":"ExRoboCop","doc":"Documentation for `ExRoboCop`.","ref":"ExRoboCop.html"},{"type":"function","title":"ExRoboCop.create_captcha/0","doc":"Create a captcha text and a captcha image","ref":"ExRoboCop.html#create_captcha/0"},{"type":"function","title":"ExRoboCop.create_form_id/1","doc":"Store captcha text under a unique ID for later retrieval","ref":"ExRoboCop.html#create_form_id/1"},{"type":"function","title":"ExRoboCop.not_a_robot?/1","doc":"Compare user answer with correct answer under uuid","ref":"ExRoboCop.html#not_a_robot?/1"},{"type":"function","title":"ExRoboCop.start/0","doc":"Put in application children to start in supervision tree","ref":"ExRoboCop.html#start/0"},{"type":"type","title":"ExRoboCop.captcha_image/0","doc":"","ref":"ExRoboCop.html#t:captcha_image/0"},{"type":"type","title":"ExRoboCop.captcha_text/0","doc":"","ref":"ExRoboCop.html#t:captcha_text/0"},{"type":"type","title":"ExRoboCop.uuid/0","doc":"","ref":"ExRoboCop.html#t:uuid/0"},{"type":"module","title":"ExRoboCop.RustCaptcha","doc":"Uses Rust to generate a captcha in the form of a tuple consisting of\na string and a base 64 encoded binary","ref":"ExRoboCop.RustCaptcha.html"},{"type":"function","title":"ExRoboCop.RustCaptcha.generate/0","doc":"","ref":"ExRoboCop.RustCaptcha.html#generate/0"},{"type":"module","title":"ExRoboCop.SecretAnswer","doc":"GenServer storing the text of the generated Captcha along with\na UIID assigned to each individual user so that the user's captcha\nanswer can be verified","ref":"ExRoboCop.SecretAnswer.html"},{"type":"function","title":"ExRoboCop.SecretAnswer.check_in/1","doc":"","ref":"ExRoboCop.SecretAnswer.html#check_in/1"},{"type":"function","title":"ExRoboCop.SecretAnswer.check_out/1","doc":"","ref":"ExRoboCop.SecretAnswer.html#check_out/1"},{"type":"function","title":"ExRoboCop.SecretAnswer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExRoboCop.SecretAnswer.html#child_spec/1"},{"type":"function","title":"ExRoboCop.SecretAnswer.start_link/1","doc":"","ref":"ExRoboCop.SecretAnswer.html#start_link/1"},{"type":"extras","title":"ExRoboCop","doc":"# ExRoboCop\n\n[![Build Status](https://github.com/corneliakelinske/ex_robo_cop/workflows/Coveralls/badge.svg)](https://github.com/corneliakelinske/ex_robo_cop) \n[![Build Status](https://github.com/corneliakelinske/ex_robo_cop/workflows/Credo/badge.svg)](https://github.com/corneliakelinske/ex_robo_cop)\n[![codecov](https://codecov.io/gh/corneliakelinske/ex_robo_cop/branch/main/graph/badge.svg?token=P3O42SF7VJ)](https://codecov.io/gh/corneliakelinske/ex_robo_cop)\n[![hex.pm](http://img.shields.io/hexpm/v/ex_robo_cop.svg?style=flat)](https://hex.pm/packages/ex_robo_cop)\n[![Build Status](https://github.com/corneliakelinske/ex_robo_cop/workflows/Dialyzer/badge.svg)](https://github.com/corneliakelinske/ex_robo_cop) \n[![Build Status](https://github.com/corneliakelinske/ex_robo_cop/workflows/Test/badge.svg)](https://github.com/corneliakelinske/ex_robo_cop) \n\n\n\nExRoboCop is a lightweight captcha library that can be used as an alternative to reCaptcha to verify that a person is \nindeed a person and not a robot.\n\nThe library uses Rust to create a captcha image and corresponding text. \nA GenServer creates a unique ID for each form in which a captcha image is used and stores the ID along with the captcha text\nso that a user's input into the infamous \"Not a Robot\" field can be verified based on the form ID.\n\nThe use of this library requires the installation of Rust.\n\nThank you to [Alan Vardy](https://github.com/alanvardy) for writing the Rust code.\n\nDocumentation can be found at [https://hexdocs.pm/ex_robo_cop](https://hexdocs.pm/ex_robo_cop).\nThis library is in use at [connie.codes](https://connie.codes/).\n\nAnd here is an example of a captcha image:\n\n![Example captcha](Captcha.jpg)","ref":"README.html"},{"type":"extras","title":"Installation - ExRoboCop","doc":"Add the package to your `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:ex_robo_cop, \"~> 0.1.4\"}\n  ]\nend\n```\n\nAdd the application to your supervision tree in the `application.ex` file, this is the GenServer that keeps track of the correct captcha answer and the form ID:\n\n``` elixir\nchildren = [\n    ExRoboCop.start()\n    ... other children\n    ]\n```\n\nAnd install Rust on your computer.","ref":"README.html#installation"},{"type":"extras","title":"For Mac users - ExRoboCop","doc":"If you have Rust installed but ExRoboCop fails to compile, try putting the following into your `~/.cargo/config`:\n\n```\n[target.x86_64-apple-darwin]\nrustflags = [\n  \"-C\", \"link-arg=-undefined\",\n  \"-C\", \"link-arg=dynamic_lookup\",\n]\n\n[target.aarch64-apple-darwin]\nrustflags = [\n  \"-C\", \"link-arg=-undefined\",\n  \"-C\", \"link-arg=dynamic_lookup\",\n]\n```","ref":"README.html#for-mac-users"},{"type":"extras","title":"Usage - ExRoboCop","doc":"`create_captcha\\0`   \ncreates a captcha text and a captcha image\n\n`create_form_id\\1`   \n creates a unique ID for a contact form and stores it in combination with the current captcha text\n\n`not_a_robot?\\1`   \nchecks whether the combination of the user's answer to the \"Not a Robot\" question and the form ID match the form ID and captcha text stored in the GenServer","ref":"README.html#usage"},{"type":"extras","title":"Example - ExRoboCop","doc":"Assuming that you want to use `ex_robo_cop` to add a captcha to the content form on your website,\nand that you are working with a `contact_controller.ex`, a `contact_view.ex` and a `new.html.heex` file, you can follow the steps below:\n\nFirst of all, you need to create the captcha text, the captcha image and the id of the new contact form in the\n`ContactController.new/2` function:\n\n```elixir\n{captcha_text, captcha_image} = ExRoboCop.create_captcha()\n\nform_id = ExRoboCop.create_form_id(captcha_text)\n```\n\nThe call to `ExRoboCop.create_form_id\\1` stores the `form_id` and the `captcha_text` as a key-value pair in the GenServer.\nThe `form_id` and the `captcha_image` will then have to be passed into the assigns of the `render\\3` function.\n\nIn the `ContactController` of my personal projects, the `new/2` function will typically look like this:\n\n```elixir\n def new(conn, _params) do\n    with {captcha_text, captcha_image} <- ExRoboCop.create_captcha() do\n      form_id = ExRoboCop.create_form_ID(captcha_text)\n\n      render(conn, \"new.html\",\n        page_title: \"Contact\",\n        changeset: Contact.changeset(%{}),\n        form_id: form_id,\n        captcha_image: captcha_image\n      )\n    end\n  end\n```\n\nThe next step is rendering the captcha image in the contact form in your `.heex` template. \nSince the image data is passed into the `render/3` assigns as binary, it needs to be converted in order to be displayed.\n\nIn Phoenix 1.6, you can add the following function to your corresponding `view.ex` file:\n\n```elixir\n  def display_captcha(captcha_image) do\n    content_tag(:img, \"\", src: \"data:image/png;base64,\" <> captcha_image)\n  end\n```\n\nand then call this function in your `heex` template:\n\n```html\n<%= display_captcha(@captcha_image) %>\n```\n\nIn Phoenix 1.5, you can convert the binary directly in the `.eex` template:\n\n```html\n  \n```\n\nThe form also needs to include an input field for users to input the letters they see in the captcha image as well\nas a hidden input field through which the `form_id` can be passed back to the controller when the form is submitted:\n\n```html\n \n  <%= label f, :not_a_robot, class: \"label\"%>\n   \n    <%= text_input f, :not_a_robot, class: \"input\", type: \"text\", placeholder: \"Please enter the letters shown below\" %>\n   \n \n\n<%= text_input f, :form_id, type: \"text\", hidden: true, value: @form_id %>\n```\n\nWhen the form is submitted, the `form_id` and the user's answer are sent back to the controller as part of the form content.\nI suggest pattern matching on them in the head of the controller's `create/2` function for example like this:\n\n```elixir\n def create(conn, %{\"content\" => %{\"not_a_robot\" => captcha_answer, \"form_id\" => form_id} = message_params}) do \n```\n\nNow, you can pass the user's answer and the form_id as a tuple into `ExRoboCop.not_a_robot?\\1` in order to verify that\nthe answer matches the captcha text stored for the respective `form_id` in the GenServer.\n\n```elixir\n  :ok = not_a_robot?({captcha_answer, form_id})  \n```","ref":"README.html#example"},{"type":"extras","title":"Production - ExRoboCop","doc":"Since `ex_robo_cop` requires Rust, you will need to add the command to install Rust to your `Dockerfile`:\n\n```\n# install build dependencies\nRUN apt-get update -y && apt-get install -y build-essential git rustc\\\n    && apt-get clean && rm -f /var/lib/apt/lists/*_*\n```","ref":"README.html#production"},{"type":"extras","title":"CHANGELOG","doc":"","ref":"CHANGELOG.html"},{"type":"extras","title":"Unreleased - CHANGELOG","doc":"","ref":"CHANGELOG.html#unreleased"},{"type":"extras","title":"v0.1.4 (2024-03-26) - CHANGELOG","doc":"- Update rust dependencies\n- Update mix dependencies\n- Update tool versions","ref":"CHANGELOG.html#v0-1-4-2024-03-26"},{"type":"extras","title":"v0.1.3 (2023-07-02) - CHANGELOG","doc":"- Update rust dependencies\n- Update mix dependencies\n- Add test to CI\n- Add test badge to README.md","ref":"CHANGELOG.html#v0-1-3-2023-07-02"},{"type":"extras","title":"v0.1.2 (2023-04-02) - CHANGELOG","doc":"- Add instructions for compiling on Mac","ref":"CHANGELOG.html#v0-1-2-2023-04-02"},{"type":"extras","title":"v0.1.1 (2022-10-05) - CHANGELOG","doc":"- Remove Postgres from github actions\n- Add Dialyzer to CI \n- Add Dialyzer badge to README.md\n- Add Dialyzer caching\n- Change environment settings for tooling\n- Upgrade tool versions\n- Update dependencies\n- Add image to README.md","ref":"CHANGELOG.html#v0-1-1-2022-10-05"},{"type":"extras","title":"v0.1.0 (2022-03-25) - CHANGELOG","doc":"- Initial release","ref":"CHANGELOG.html#v0-1-0-2022-03-25"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}